diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-mode.h ns-3.44/src/wifi/model/wifi-mode.h
--- ns-3.43/src/wifi/model/wifi-mode.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-mode.h	2025-03-09 16:55:49.803372600 -0700
@@ -26,107 +26,107 @@
 class WifiTxVector;
 
 /**
- * \brief represent a single transmission mode
- * \ingroup wifi
+ * @brief represent a single transmission mode
+ * @ingroup wifi
  *
  * A WifiMode is implemented by a single integer which is used
  * to lookup in a global array the characteristics of the
  * associated transmission mode. It is thus extremely cheap to
  * keep a WifiMode variable around.
  *
- * \see attribute_WifiMode
+ * @see attribute_WifiMode
  */
 class WifiMode
 {
   public:
     /**
-     * \returns true if this <MCS, channel width, NSS> combination is allowed, false otherwise.
+     * @returns true if this <MCS, channel width, NSS> combination is allowed, false otherwise.
      *
-     * \param channelWidth the considered channel width
-     * \param nss the considered number of streams
+     * @param channelWidth the considered channel width
+     * @param nss the considered number of streams
      */
     bool IsAllowed(MHz_u channelWidth, uint8_t nss) const;
     /**
-     * \returns true if this TXVECTOR combination is allowed, false otherwise.
+     * @returns true if this TXVECTOR combination is allowed, false otherwise.
      *
-     * \param txVector the const WifiTxVector& of the signal
+     * @param txVector the const WifiTxVector& of the signal
      */
     bool IsAllowed(const WifiTxVector& txVector) const;
     /**
      *
-     * \param channelWidth the considered channel width
-     * \param guardInterval the considered guard interval duration
-     * \param nss the considered number of streams
+     * @param channelWidth the considered channel width
+     * @param guardInterval the considered guard interval duration
+     * @param nss the considered number of streams
      *
-     * \returns the physical bit rate of this signal in bps.
+     * @returns the physical bit rate of this signal in bps.
      *
      * If a transmission mode uses 1/2 FEC, and if its
      * data rate is 3.25Mbps, the PHY rate is 6.5Mbps
      */
     uint64_t GetPhyRate(MHz_u channelWidth, Time guardInterval, uint8_t nss) const;
     /**
-     * \param txVector the const WifiTxVector& of the signal
-     * \param staId the station ID for MU (unused if SU)
+     * @param txVector the const WifiTxVector& of the signal
+     * @param staId the station ID for MU (unused if SU)
      *
-     * \returns the physical bit rate of this signal in bps.
+     * @returns the physical bit rate of this signal in bps.
      *
      * If a transmission mode uses 1/2 FEC, and if its
      * data rate is 3.25Mbps, the PHY rate is 6.5Mbps
      */
     uint64_t GetPhyRate(const WifiTxVector& txVector, uint16_t staId = SU_STA_ID) const;
     /**
-     * \param channelWidth the considered channel width
+     * @param channelWidth the considered channel width
      *
-     * \returns the physical bit rate of this non-HT signal.
+     * @returns the physical bit rate of this non-HT signal.
      */
     uint64_t GetPhyRate(MHz_u channelWidth) const;
     /**
      *
-     * \param channelWidth the considered channel width
-     * \param guardInterval the considered guard interval duration
-     * \param nss the considered number of streams
+     * @param channelWidth the considered channel width
+     * @param guardInterval the considered guard interval duration
+     * @param nss the considered number of streams
      *
-     * \returns the data bit rate of this signal in bps.
+     * @returns the data bit rate of this signal in bps.
      */
     uint64_t GetDataRate(MHz_u channelWidth, Time guardInterval, uint8_t nss) const;
     /**
-     * \param txVector the const WifiTxVector& of the signal
-     * \param staId the station ID for MU (unused if SU)
+     * @param txVector the const WifiTxVector& of the signal
+     * @param staId the station ID for MU (unused if SU)
      *
-     * \returns the data bit rate of this signal.
+     * @returns the data bit rate of this signal.
      */
     uint64_t GetDataRate(const WifiTxVector& txVector, uint16_t staId = SU_STA_ID) const;
     /**
-     * \param channelWidth the considered channel width
+     * @param channelWidth the considered channel width
      *
-     * \returns the data bit rate of this non-HT.
+     * @returns the data bit rate of this non-HT.
      */
     uint64_t GetDataRate(MHz_u channelWidth) const;
 
     /**
-     * \returns the coding rate of this transmission mode
+     * @returns the coding rate of this transmission mode
      */
     WifiCodeRate GetCodeRate() const;
     /**
-     * \returns the size of the modulation constellation.
+     * @returns the size of the modulation constellation.
      */
     uint16_t GetConstellationSize() const;
     /**
-     * \returns the MCS value.
+     * @returns the MCS value.
      */
     uint8_t GetMcsValue() const;
     /**
-     * \returns a human-readable representation of this WifiMode
+     * @returns a human-readable representation of this WifiMode
      * instance.
      */
     const std::string& GetUniqueName() const;
     /**
-     * \returns true if this mode is a mandatory mode, false
+     * @returns true if this mode is a mandatory mode, false
      *          otherwise.
      */
     bool IsMandatory() const;
     /**
-     * \returns the UID associated to this wireless mode.
+     * @returns the UID associated to this wireless mode.
      *
      * Each specific wireless mode should have a different UID.
      * For example, the 802.11b 1Mbps and the 802.11b 2Mbps modes
@@ -135,12 +135,12 @@
     uint32_t GetUid() const;
     /**
      *
-     * \returns the Modulation Class (Section 9.7.8 "Modulation classes"; IEEE 802.11-2012)
+     * @returns the Modulation Class (Section 9.7.8 "Modulation classes"; IEEE 802.11-2012)
      * to which this WifiMode belongs.
      */
     WifiModulationClass GetModulationClass() const;
     /**
-     * \returns the rate (in bps) of the non-HT Reference Rate
+     * @returns the rate (in bps) of the non-HT Reference Rate
      * which corresponds to the HT MCS of this WifiMode.
      *
      * To convert an HT MCS to is corresponding non-HT Reference Rate
@@ -149,14 +149,14 @@
      */
     uint64_t GetNonHtReferenceRate() const;
     /**
-     * \param mode the WifiMode
-     * \returns true if this WifiMode has a
+     * @param mode the WifiMode
+     * @returns true if this WifiMode has a
      * a code rate strictly higher than mode.
      */
     bool IsHigherCodeRate(WifiMode mode) const;
     /**
-     * \param mode the WifiMode
-     * \returns true if this WifiMode has a
+     * @param mode the WifiMode
+     * @returns true if this WifiMode has a
      * a rate strictly higher than mode.
      */
     bool IsHigherDataRate(WifiMode mode) const;
@@ -172,7 +172,7 @@
      * Create a WifiMode if the given string represents a valid
      * WifiMode name.
      *
-     * \param name std::string of a valid WifiMode name
+     * @param name std::string of a valid WifiMode name
      */
     WifiMode(std::string name);
 
@@ -182,7 +182,7 @@
     /**
      * Create a WifiMode from a given unique ID.
      *
-     * \param uid unique ID
+     * @param uid unique ID
      */
     WifiMode(uint32_t uid);
     uint32_t m_uid; ///< UID
@@ -191,10 +191,10 @@
 /**
  * Check if the two WifiModes are identical.
  *
- * \param a WifiMode
- * \param b WifiMode
+ * @param a WifiMode
+ * @param b WifiMode
  *
- * \return true if the two WifiModes are identical,
+ * @return true if the two WifiModes are identical,
  *         false otherwise
  */
 bool operator==(const WifiMode& a, const WifiMode& b);
@@ -202,10 +202,10 @@
 /**
  * Check if the two WifiModes are different.
  *
- * \param a WifiMode
- * \param b WifiMode
+ * @param a WifiMode
+ * @param b WifiMode
  *
- * \return true if the two WifiModes are different,
+ * @return true if the two WifiModes are different,
  *         false otherwise
  */
 bool operator!=(const WifiMode& a, const WifiMode& b);
@@ -213,10 +213,10 @@
 /**
  * Compare two WifiModes
  *
- * \param a WifiMode
- * \param b WifiMode
+ * @param a WifiMode
+ * @param b WifiMode
  *
- * \return true if a is less than b,
+ * @return true if a is less than b,
  *         false otherwise
  */
 bool operator<(const WifiMode& a, const WifiMode& b);
@@ -224,19 +224,19 @@
 /**
  * Serialize WifiMode to ostream (human-readable).
  *
- * \param os the output stream
- * \param mode the WifiMode
+ * @param os the output stream
+ * @param mode the WifiMode
  *
- * \return std::ostream
+ * @return std::ostream
  */
 std::ostream& operator<<(std::ostream& os, const WifiMode& mode);
 /**
  * Serialize WifiMode from istream (human-readable).
  *
- * \param is the input stream
- * \param mode the WifiMode
+ * @param is the input stream
+ * @param mode the WifiMode
  *
- * \return std::istream
+ * @return std::istream
  */
 std::istream& operator>>(std::istream& is, WifiMode& mode);
 
@@ -255,7 +255,7 @@
 typedef WifiModeList::const_iterator WifiModeListIterator;
 
 /**
- * \brief create WifiMode class instances and keep track of them.
+ * @brief create WifiMode class instances and keep track of them.
  *
  * This factory ensures that each WifiMode created has a unique name
  * and assigns to each of them a unique integer.
@@ -266,21 +266,21 @@
     // Typedefs for callbacks used by WifiModeItem
     /**
      * Typedef for callback used to retrieve code rate of a WifiMode
-     * \return the code rate of the WifiMode.
+     * @return the code rate of the WifiMode.
      */
     typedef Callback<WifiCodeRate> CodeRateCallback;
     /**
      * Typedef for callback used to retrieve constellation size of a WifiMode
-     * \return the size of modulation constellation of the WifiMode.
+     * @return the size of modulation constellation of the WifiMode.
      */
     typedef Callback<uint16_t> ConstellationSizeCallback;
     /**
      * Typedef for callback used to calculate PHY rate of a WifiMode
      * from a TXVECTOR.
      *
-     * \param txVector the TXVECTOR used for the transmission
-     * \param staId the station ID
-     * \return the physical bit rate of the signal in bps.
+     * @param txVector the TXVECTOR used for the transmission
+     * @param staId the station ID
+     * @return the physical bit rate of the signal in bps.
      */
     typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */>
         PhyRateCallback;
@@ -288,9 +288,9 @@
      * Typedef for callback used to calculate data rate of a WifiMode
      * from a TXVECTOR.
      *
-     * \param txVector the TXVECTOR used for the transmission
-     * \param staId the station ID
-     * \return the data rate of the signal in bps.
+     * @param txVector the TXVECTOR used for the transmission
+     * @param staId the station ID
+     * @return the data rate of the signal in bps.
      */
     typedef Callback<uint64_t, const WifiTxVector& /* txVector */, uint16_t /* staId */>
         DataRateCallback;
@@ -299,37 +299,37 @@
      * an MCS defined in HT or later amendment. For Non-HT modes (DSSS, OFDM,
      * etc) this should be defined as null.
      *
-     * \return the rate (in bps) of the non-HT Reference Rate.
+     * @return the rate (in bps) of the non-HT Reference Rate.
      */
     typedef Callback<uint64_t> NonHtReferenceRateCallback;
     /**
      * Typedef for callback used to check whether a given combination is allowed
      *
-     * \param txVector the TXVECTOR containing the combination to check
-     * \return true if combination of current WifiMode and TXVECTOR is allowed.
+     * @param txVector the TXVECTOR containing the combination to check
+     * @return true if combination of current WifiMode and TXVECTOR is allowed.
      */
     typedef Callback<bool, const WifiTxVector& /* txVector */> AllowedCallback;
 
     /**
-     * \param uniqueName the name of the associated WifiMode. This name
+     * @param uniqueName the name of the associated WifiMode. This name
      *        must be unique across _all_ instances.
-     * \param modClass the class of modulation
-     * \param isMandatory true if this WifiMode is mandatory, false otherwise.
-     * \param codeRateCallback a callback function to retrieve coding rate of
+     * @param modClass the class of modulation
+     * @param isMandatory true if this WifiMode is mandatory, false otherwise.
+     * @param codeRateCallback a callback function to retrieve coding rate of
      *        this WifiMode. If convolutional coding is used for this rate
      *        then the callback returns the convolutional coding rate used. If
      *        there is no explicit convolutional coding step (e.g., for DSSS
      *        rates) then the callback should returns WIFI_CODE_RATE_UNDEFINED.
-     * \param constellationSizeCallback a callback function that returns the
+     * @param constellationSizeCallback a callback function that returns the
      *        order of the constellation used.
-     * \param phyRateCallback a callback function to calculate the PHY rate (in
+     * @param phyRateCallback a callback function to calculate the PHY rate (in
      *        bps) of this WifiMode.
-     * \param dataRateCallback a callback function to calculate the data rate
+     * @param dataRateCallback a callback function to calculate the data rate
      *        (in bps) of this WifiMode.
-     * \param isAllowedCallback a callback function to check whether a
+     * @param isAllowedCallback a callback function to check whether a
      *        specific combination of this WifiMode is allowed.
      *
-     * \return WifiMode
+     * @return WifiMode
      *
      * Create a non-HT WifiMode.
      */
@@ -343,25 +343,25 @@
                                    AllowedCallback isAllowedCallback);
 
     /**
-     * \param uniqueName the name of the associated WifiMode. This name
+     * @param uniqueName the name of the associated WifiMode. This name
      *        must be unique across _all_ instances.
-     * \param mcsValue the MCS value
-     * \param modClass the class of modulation
-     * \param isMandatory true if this WifiMode is mandatory, false otherwise.
-     * \param codeRateCallback a callback function that returns the coding rate
+     * @param mcsValue the MCS value
+     * @param modClass the class of modulation
+     * @param isMandatory true if this WifiMode is mandatory, false otherwise.
+     * @param codeRateCallback a callback function that returns the coding rate
      *        of this WifiMode.
-     * \param constellationSizeCallback a callback function that returns the size
+     * @param constellationSizeCallback a callback function that returns the size
      *        of modulation constellation of this WifiMode.
-     * \param phyRateCallback a callback function to calculate the PHY rate (in
+     * @param phyRateCallback a callback function to calculate the PHY rate (in
      *        bps) of this WifiMode.
-     * \param dataRateCallback a callback function to calculate the data rate (in
+     * @param dataRateCallback a callback function to calculate the data rate (in
      *        bps) of this WifiMode.
-     * \param nonHtReferenceRateCallback a callback function to calculate the rate
+     * @param nonHtReferenceRateCallback a callback function to calculate the rate
      *        (in bps) of the non-HT Reference Rate of this WifiMode.
-     * \param isAllowedCallback a callback function to calculate whether a given
+     * @param isAllowedCallback a callback function to calculate whether a given
      *        combination of is allowed for this WifiMode.
      *
-     * \return WifiMode
+     * @return WifiMode
      *
      * Create a HT or later WifiMode.
      */
@@ -384,7 +384,7 @@
     /**
      * Return a WifiModeFactory
      *
-     * \return a WifiModeFactory
+     * @return a WifiModeFactory
      */
     static WifiModeFactory* GetFactory();
     WifiModeFactory();
@@ -419,25 +419,25 @@
     /**
      * Search and return WifiMode from a given name.
      *
-     * \param name human-readable WifiMode
+     * @param name human-readable WifiMode
      *
-     * \return the WifiMode
+     * @return the WifiMode
      */
     WifiMode Search(std::string name) const;
     /**
      * Allocate a WifiModeItem from a given uniqueUid.
      *
-     * \param uniqueUid the unique UID
+     * @param uniqueUid the unique UID
      *
-     * \return the allocated UID index
+     * @return the allocated UID index
      */
     uint32_t AllocateUid(std::string uniqueUid);
     /**
      * Return a WifiModeItem at the given UID index.
      *
-     * \param uid the UID index
+     * @param uid the UID index
      *
-     * \return WifiModeItem at the given UID
+     * @return WifiModeItem at the given UID
      */
     WifiModeItem* Get(uint32_t uid);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-mpdu.cc ns-3.44/src/wifi/model/wifi-mpdu.cc
--- ns-3.43/src/wifi/model/wifi-mpdu.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-mpdu.cc	2025-03-09 16:55:49.803372600 -0700
@@ -29,6 +29,7 @@
     auto& original = std::get<OriginalInfo>(m_instanceInfo);
     original.m_packet = p;
     original.m_timestamp = stamp;
+    original.m_retryCount = 0;
 
     if (header.IsQosData() && header.IsQosAmsdu())
     {
@@ -113,6 +114,41 @@
     return std::get<OriginalInfo>(origInstanceInfo).m_timestamp;
 }
 
+uint32_t
+WifiMpdu::GetRetryCount() const
+{
+    if (auto original = std::get_if<ORIGINAL>(&m_instanceInfo))
+    {
+        return original->m_retryCount;
+    }
+    const auto& origInstanceInfo = std::get<Ptr<WifiMpdu>>(m_instanceInfo)->m_instanceInfo;
+    return std::get<OriginalInfo>(origInstanceInfo).m_retryCount;
+}
+
+void
+WifiMpdu::IncrementRetryCount()
+{
+    NS_LOG_FUNCTION(this);
+
+    if (m_header.IsBlockAckReq() || m_header.IsTrigger())
+    {
+        // this function may be called for these frames, but a retry count must not be maintained
+        // for them
+        return;
+    }
+
+    NS_ABORT_MSG_UNLESS(m_header.IsData() || m_header.IsMgt(),
+                        "Frame retry count is not maintained for frames of type "
+                            << m_header.GetTypeString());
+    if (auto original = std::get_if<ORIGINAL>(&m_instanceInfo))
+    {
+        ++original->m_retryCount;
+        return;
+    }
+    auto& origInstanceInfo = std::get<Ptr<WifiMpdu>>(m_instanceInfo)->m_instanceInfo;
+    ++std::get<OriginalInfo>(origInstanceInfo).m_retryCount;
+}
+
 const WifiMacHeader&
 WifiMpdu::GetHeader() const
 {
@@ -181,6 +217,7 @@
         // An MSDU is going to be aggregated to this MPDU, hence this has to be an A-MSDU now
         Ptr<const WifiMpdu> firstMsdu = Create<const WifiMpdu>(*this);
         original.m_packet = Create<Packet>();
+        original.m_retryCount = 0;
         DoAggregate(firstMsdu);
 
         m_header.SetQosAmsdu();
@@ -370,7 +407,8 @@
 void
 WifiMpdu::Print(std::ostream& os) const
 {
-    os << m_header << ", payloadSize=" << GetPacketSize() << ", queued=" << IsQueued();
+    os << m_header << ", payloadSize=" << GetPacketSize() << ", retryCount=" << GetRetryCount()
+       << ", queued=" << IsQueued();
     if (IsQueued())
     {
         os << ", residualLifetime=" << (GetExpiryTime() - Simulator::Now()).As(Time::US)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-mpdu.h ns-3.44/src/wifi/model/wifi-mpdu.h
--- ns-3.43/src/wifi/model/wifi-mpdu.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-mpdu.h	2025-03-09 16:55:49.803372600 -0700
@@ -28,7 +28,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * Tag used to allow (only) WifiMacQueue to access the queue iterator stored
  * by a WifiMpdu.
@@ -40,7 +40,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * WifiMpdu stores a (const) packet along with a MAC header. To support 802.11be
  * Multi-Link Operation (MLO), a WifiMpdu variant, referred to as WifiMpdu alias,
@@ -51,79 +51,79 @@
 {
   public:
     /**
-     * \brief Create a Wifi MAC queue item containing a packet and a Wifi MAC header.
-     * \param p the const packet included in the created item.
-     * \param header the Wifi MAC header included in the created item.
-     * \param stamp the timestamp to associate with the MPDU
+     * @brief Create a Wifi MAC queue item containing a packet and a Wifi MAC header.
+     * @param p the const packet included in the created item.
+     * @param header the Wifi MAC header included in the created item.
+     * @param stamp the timestamp to associate with the MPDU
      */
     WifiMpdu(Ptr<const Packet> p, const WifiMacHeader& header, Time stamp = Simulator::Now());
 
     virtual ~WifiMpdu();
 
     /**
-     * \return whether this is the original version of the MPDU
+     * @return whether this is the original version of the MPDU
      */
     bool IsOriginal() const;
 
     /**
-     * \return the original version of this MPDU
+     * @return the original version of this MPDU
      */
     Ptr<const WifiMpdu> GetOriginal() const;
 
     /**
-     * \brief Get the packet stored in this item
-     * \return the packet stored in this item.
+     * @brief Get the packet stored in this item
+     * @return the packet stored in this item.
      */
     Ptr<const Packet> GetPacket() const;
 
     /**
-     * \brief Get the header stored in this item
-     * \return the header stored in this item.
+     * @brief Get the header stored in this item
+     * @return the header stored in this item.
      */
     const WifiMacHeader& GetHeader() const;
 
     /**
-     * \brief Get the header stored in this item
-     * \return the header stored in this item.
+     * @brief Get the header stored in this item
+     * @return the header stored in this item.
      */
     WifiMacHeader& GetHeader();
 
     /**
-     * \brief Return the destination address present in the header
-     * \return the destination address
+     * @brief Return the destination address present in the header
+     * @return the destination address
      */
     Mac48Address GetDestinationAddress() const;
 
     /**
-     * \brief Return the size of the packet stored by this item, including header
+     * @brief Return the size of the packet stored by this item, including header
      *        size and trailer size
      *
-     * \return the size of the packet stored by this item in bytes.
+     * @return the size of the packet stored by this item in bytes.
      */
     uint32_t GetSize() const;
 
     /**
-     * \brief Return the size in bytes of the packet or control header or management
+     * @brief Return the size in bytes of the packet or control header or management
      *        header stored by this item.
      *
-     * \return the size in bytes of the packet or control header or management header
+     * @return the size in bytes of the packet or control header or management header
      *         stored by this item
      */
     uint32_t GetPacketSize() const;
 
     /**
      * Return true if this item contains an MSDU fragment, false otherwise
-     * \return true if this item contains an MSDU fragment, false otherwise
+     * @return true if this item contains an MSDU fragment, false otherwise
      */
     bool IsFragment() const;
 
     /**
-     * \brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
+     * @brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
      *        constituting an A-MSDU). Note that the given MPDU cannot contain
      *        an A-MSDU. If the given MPDU is a null pointer, the effect of this
      *        call is to add only an A-MSDU subframe header, thus producing an A-MSDU
      *        containing a single MSDU.
-     * \param msdu the MPDU containing the MSDU to aggregate
+     * @param msdu the MPDU containing the MSDU to aggregate
      */
     void Aggregate(Ptr<const WifiMpdu> msdu);
 
@@ -134,15 +134,15 @@
         DeaggregatedMsdusCI;
 
     /**
-     * \brief Get a constant iterator pointing to the first MSDU in the list of aggregated MSDUs.
+     * @brief Get a constant iterator pointing to the first MSDU in the list of aggregated MSDUs.
      *
-     * \return a constant iterator pointing to the first MSDU in the list of aggregated MSDUs
+     * @return a constant iterator pointing to the first MSDU in the list of aggregated MSDUs
      */
     DeaggregatedMsdusCI begin() const;
     /**
-     * \brief Get a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs.
+     * @brief Get a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs.
      *
-     * \return a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs
+     * @return a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs
      */
     DeaggregatedMsdusCI end() const;
 
@@ -152,64 +152,74 @@
     /**
      * Set the queue iterator stored by this object.
      *
-     * \param queueIt the queue iterator for this object
-     * \param tag a wifi MAC queue iterator tag (allows only WifiMacQueue to call this method)
+     * @param queueIt the queue iterator for this object
+     * @param tag a wifi MAC queue iterator tag (allows only WifiMacQueue to call this method)
      */
     void SetQueueIt(std::optional<Iterator> queueIt, WmqIteratorTag tag);
     /**
-     * \param tag a wifi MAC queue iterator tag (allows only WifiMacQueue to call this method)
-     * \return the queue iterator stored by this object
+     * @param tag a wifi MAC queue iterator tag (allows only WifiMacQueue to call this method)
+     * @return the queue iterator stored by this object
      */
     Iterator GetQueueIt(WmqIteratorTag tag) const;
 
     /**
      * Return true if this item is stored in some queue, false otherwise.
      *
-     * \return true if this item is stored in some queue, false otherwise
+     * @return true if this item is stored in some queue, false otherwise
      */
     bool IsQueued() const;
     /**
      * Get the AC of the queue this item is stored into. Abort if this item
      * is not stored in a queue.
      *
-     * \return the AC of the queue this item is stored into
+     * @return the AC of the queue this item is stored into
      */
     AcIndex GetQueueAc() const;
     /**
-     * \return the time this MPDU was constructed
+     * @return the time this MPDU was constructed
      */
     Time GetTimestamp() const;
     /**
-     * \return the expiry time of this MPDU
+     * @return the expiry time of this MPDU
      */
     Time GetExpiryTime() const;
 
     /**
-     * \brief Get the MAC protocol data unit (MPDU) corresponding to this item
+     * @return the frame retry count
+     */
+    uint32_t GetRetryCount() const;
+
+    /**
+     * Increment the frame retry count.
+     */
+    void IncrementRetryCount();
+
+    /**
+     * @brief Get the MAC protocol data unit (MPDU) corresponding to this item
      *        (i.e. a copy of the packet stored in this item wrapped with MAC
      *        header and trailer)
-     * \return the MAC protocol data unit corresponding to this item.
+     * @return the MAC protocol data unit corresponding to this item.
      */
     Ptr<Packet> GetProtocolDataUnit() const;
 
     /**
      * Mark this MPDU as being in flight on the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void SetInFlight(uint8_t linkId) const;
     /**
      * Mark this MPDU as not being in flight on the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void ResetInFlight(uint8_t linkId) const;
     /**
-     * \return the set of IDs of the links on which this MPDU is currently in flight
+     * @return the set of IDs of the links on which this MPDU is currently in flight
      */
     std::set<uint8_t> GetInFlightLinkIds() const;
     /**
-     * \return true if this MPDU is in flight on any link, false otherwise
+     * @return true if this MPDU is in flight on any link, false otherwise
      */
     bool IsInFlight() const;
 
@@ -217,11 +227,11 @@
      * Set the sequence number of this MPDU (and of the original copy, if this is an alias)
      * to the given value. Also, record that a sequence number has been assigned to this MPDU.
      *
-     * \param seqNo the given sequence number
+     * @param seqNo the given sequence number
      */
     void AssignSeqNo(uint16_t seqNo);
     /**
-     * \return whether a sequence number has been assigned to this MPDU
+     * @return whether a sequence number has been assigned to this MPDU
      */
     bool HasSeqNoAssigned() const;
     /**
@@ -234,28 +244,28 @@
      * on the link with the given ID. Aliases have their own copy of the MAC header and
      * cannot be used to perform non-const operations on the frame body.
      *
-     * \param linkId the ID of the given link
-     * \return an alias for this MPDU
+     * @param linkId the ID of the given link
+     * @return an alias for this MPDU
      */
     Ptr<WifiMpdu> CreateAlias(uint8_t linkId) const;
 
     /**
-     * \brief Print the item contents.
-     * \param os output stream in which the data should be printed.
+     * @brief Print the item contents.
+     * @param os output stream in which the data should be printed.
      */
     virtual void Print(std::ostream& os) const;
 
   private:
     /**
-     * \brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
+     * @brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
      *        constituting an A-MSDU). Note that the given MPDU cannot contain
      *        an A-MSDU.
-     * \param msdu the MPDU containing the MSDU to aggregate
+     * @param msdu the MPDU containing the MSDU to aggregate
      */
     void DoAggregate(Ptr<const WifiMpdu> msdu);
 
     /**
-     * \return the queue iterator stored by this object
+     * @return the queue iterator stored by this object
      */
     Iterator GetQueueIt() const;
 
@@ -279,14 +289,15 @@
         DeaggregatedMsdus m_msduList;      //!< list of aggregated MSDUs included in this MPDU
         std::optional<Iterator> m_queueIt; //!< Queue iterator pointing to this MPDU, if queued
         bool m_seqNoAssigned;              //!< whether a sequence number has been assigned
+        uint32_t m_retryCount; //!< the frame retry count maintained for each MSDU, A-MSDU or MMPDU
     };
 
     /**
-     * \return a reference to the information held by the original copy of the MPDU.
+     * @return a reference to the information held by the original copy of the MPDU.
      */
     OriginalInfo& GetOriginalInfo();
     /**
-     * \return a const reference to the information held by the original copy of the MPDU.
+     * @return a const reference to the information held by the original copy of the MPDU.
      */
     const OriginalInfo& GetOriginalInfo() const;
 
@@ -300,11 +311,11 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the output stream
- * \param item the WifiMpdu
- * \returns a reference to the stream
+ * @param os the output stream
+ * @param item the WifiMpdu
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const WifiMpdu& item);
 
